#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_OutFile=BootSectGui.exe
; #AutoIt3Wrapper_Compile_Both=y
#AutoIt3Wrapper_OutFile_X64=BootSectGuiX64.exe
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_icon=BootSectGui.ico
#AutoIt3Wrapper_UseUpx=n
; #AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Res_Comment=-
#AutoIt3Wrapper_Res_Description=BootSectGui.exe
#AutoIt3Wrapper_Res_Fileversion=0.2.0.0
#AutoIt3Wrapper_Res_Fileversion_AutoIncrement=n
#AutoIt3Wrapper_Res_LegalCopyright=AZJIO
#AutoIt3Wrapper_Res_Language=1033
#AutoIt3Wrapper_Run_AU3Check=n
#AutoIt3Wrapper_Res_Field=Version|0.2
#AutoIt3Wrapper_Res_Field=Build|2013.09.20
#AutoIt3Wrapper_Res_Field=Coded by|AZJIO
#AutoIt3Wrapper_Res_Field=CompanyName|AZJIO_Soft
#AutoIt3Wrapper_Res_Field=Compile date|%longdate% %time%
#AutoIt3Wrapper_Res_Field=AutoIt Version|%AutoItVer%
#AutoIt3Wrapper_Run_Obfuscator=y
#Obfuscator_Parameters=/sf /sv /om /cs=0 /cn=0
; #Obfuscator_Parameters=/SO
#AutoIt3Wrapper_Run_After=del /f /q "%scriptdir%\%scriptfile%_Obfuscated.au3"
#endregion ;**** Directives created by AutoIt3Wrapper_GUI ****

;  @AZJIO 2013.09.20 AutoIt3_v3.3.8.1

Opt('MustDeclareVars', 1)
#NoTrayIcon
#include <GuiConstantsEx.au3>
#include <Constants.au3>
#include <GuiConstantsEx.au3>
#include <ComboConstants.au3>
#include <WindowsConstants.au3>
#include <Encoding.au3>
#include <UserGUI.au3>

Local $sTitle = "BootSectGui", $sPathBootSect, $sList, $Current, $sp, $sLog, $tmp, $sDash
; GUI + ID
Local $hGUI, $msg, $iNT60, $iNT52, $iCh_MBR, $iCh_Force, $iCombo, $iBtnStart, $iBtnHelp, $iBtnLog, $iStatusBar

Local $Lng[22]
$Lng[1] = 'BootSect.exe not found.'
$Lng[2] = 'Completion of the program.'
$Lng[3] = 'Not found any disk'
$Lng[4] = 'Completion of the program'
$Lng[5] = 'Operating system'
$Lng[6] = '/nt52 (ntldr, Windows XP)'
$Lng[7] = '/nt60 (bootmgr, Windows Vista/7/8)'
$Lng[8] = 'Options'
$Lng[9] = 'MBR'
$Lng[10] = 'Force'
$Lng[11] = 'Log'
$Lng[12] = 'Start'
$Lng[13] = 'Error'
$Lng[14] = 'The log is available after the operation.'
$Lng[15] = '(successfully)'
$Lng[16] = 'Options'
$Lng[17] = 'Bootsect = Start'
$Lng[18] = 'Bootsect = End'
$Lng[19] = 'Viewing'
$Lng[20] = 'Gb'
$Lng[21] = 'Error'

If @OSLang = 0419 Then
	$Lng[1] = '  BootSect.exe.'
	$Lng[2] = ' .'
	$Lng[3] = '    '
	$Lng[4] = ' '
	$Lng[5] = ' '
	; $Lng[6] = '/nt52 (ntldr, Windows XP)'
	; $Lng[7] = '/nt60 (bootmgr, Windows Vista/7/8)'
	$Lng[8] = ''
	; $Lng[9] = 'MBR'
	; $Lng[10] = 'Force'
	$Lng[11] = ''
	$Lng[12] = ''
	$Lng[13] = ''
	$Lng[14] = '    .'
	$Lng[15] = '()'
	$Lng[16] = ''
	$Lng[17] = 'Bootsect = '
	$Lng[18] = 'Bootsect = '
	$Lng[19] = ''
	$Lng[20] = ''
	$Lng[21] = ''
EndIf
If StringLen($Lng[20]) > 2 Then $Lng[20] = StringLeft($Lng[20], 2)

_AddDash('-', 84, $Lng[16])
_AddDash('-', 84, $Lng[17])
_AddDash('-', 84, $Lng[18])

FileChangeDir(@ScriptDir)

$sPathBootSect = _GetPath('bootsect.exe')
If @error Then Exit MsgBox(16 + 262144, $sTitle, $Lng[1] & @LF & $Lng[2])

$sp = Chr(1)
Opt('GUIDataSeparatorChar', $sp)
$sList = _GetDrv()
If Not $sList Then Exit MsgBox(4096, $sTitle, $Lng[3] & @LF & $Lng[4])

$hGUI = GUICreate($sTitle, 440, 130)
If Not @Compiled Then GUISetIcon(@ScriptDir & '\BootSectGui.ico')

$Current = StringRegExp($sList, '(?:\A|\001)([C-Z]: Fixed.*?)(?=\001)', 1)
If @error Then
	$Current = StringLeft($sList, StringInStr($sList & $sp, $sp) - 1)
Else
	$Current = $Current[0]
EndIf
$iCombo = GUICtrlCreateCombo('', 20, 16, 400, 25, $WS_VSCROLL + $CBS_DROPDOWNLIST)
GUICtrlSetFont(-1, -1, -1, 0, 'Courier New')
GUICtrlSendMsg(-1, 0x160, 370, 0)
GUICtrlSetData(-1, $sList & $sp & '/SYS' & $sp & '/ALL', $Current)

;  
GUICtrlCreateGroup($Lng[5], 20, 45, 200, 60)
$iNT52 = GUICtrlCreateRadio($Lng[6], 27, 60, 188, 20)
$iNT60 = GUICtrlCreateRadio($Lng[7], 27, 80, 188, 20)
GUICtrlSetState(-1, $GUI_CHECKED)
GUICtrlCreateGroup('', -99, -99, 1, 1) ;close group

; 
GUICtrlCreateGroup($Lng[8], 230, 45, 62, 60)
$iCh_MBR = GUICtrlCreateCheckbox($Lng[9], 237, 60, 53, 20)
; GUICtrlSetState(-1, $GUI_CHECKED)
$iCh_Force = GUICtrlCreateCheckbox($Lng[10], 237, 80, 53, 20)
GUICtrlCreateGroup('', -99, -99, 1, 1) ;close group

; $iBtnHelp = GUICtrlCreateButton('Help', 300, 50, 57, 27)
; GUICtrlSetState(-1, $GUI_FOCUS + $GUI_DEFBUTTON)
; $iBtnLog = GUICtrlCreateButton($Lng[11], 363, 50, 57, 27)
; $iBtnStart = GUICtrlCreateButton($Lng[12], 300, 80, 120, 27)

$iBtnHelp = GUICtrlCreateButton('?', 300, 50, 30, 27)
GUICtrlSetState(-1, $GUI_FOCUS + $GUI_DEFBUTTON)
$iBtnLog = GUICtrlCreateButton($Lng[11], 300, 80, 30, 27)
$iBtnStart = GUICtrlCreateButton($Lng[12], 333, 50, 87, 57)
GUICtrlSetFont(-1, 12)

$iStatusBar = GUICtrlCreateLabel('bootsect.exe' & _GetComString(), 20, 110, 420, 17)

GUISetState()

While 1
	Switch GUIGetMsg()
		Case $iBtnLog
			If $sLog Then
				_Viewing($hGUI, $sLog)
			Else
				MsgBox(0, $Lng[13], $Lng[14], 0, $hGUI)
			EndIf
		Case $iBtnHelp
			$tmp = _Help()
			If $tmp Then _Viewing($hGUI, $tmp)
		Case $iBtnStart
			$sLog = _BootSect()
		Case $iCombo, $iNT52, $iNT60, $iCh_MBR, $iCh_Force
			GUICtrlSetData($iStatusBar, 'bootsect.exe' & _GetComString())
		Case $GUI_EVENT_CLOSE
			Exit
	EndSwitch
WEnd

Func _GetComString()
	Local $sComString, $tmp
	If GUICtrlRead($iNT60) = $GUI_CHECKED Then
		$sComString &= ' /nt60'
	Else
		$sComString &= ' /nt52'
	EndIf
	$tmp = GUICtrlRead($iCombo)
	Switch $tmp
		Case '/SYS'
			$sComString &= ' /SYS'
		Case '/ALL'
			$sComString &= ' /ALL'
		Case Else
			$tmp = StringRegExp($tmp, '(?i)^.{6}([a-z]:).+', 1)
			If @error Then
				Return SetError(1, 0, $Lng[21])
			Else
				$sComString &= ' ' & $tmp[0]
			EndIf
	EndSwitch
	If GUICtrlRead($iCh_MBR) = $GUI_CHECKED Then $sComString &= ' /mbr'
	If GUICtrlRead($iCh_Force) = $GUI_CHECKED Then $sComString &= ' /force'
	Return $sComString
EndFunc   ;==>_GetComString

Func _BootSect()
	GUICtrlSetState($iBtnStart, $GUI_DISABLE)
	Local $iPID, $sOut, $tmp, $sComString = _GetComString()
	If @error Then
		GUICtrlSetData($iStatusBar, $Lng[21])
		Return SetError(1, 0, $Lng[21])
	EndIf

	$iPID = Run('"' & $sPathBootSect & '"' & $sComString, @ScriptDir, @SW_HIDE, $STDOUT_CHILD)
	While 1
		$tmp = StdoutRead($iPID)
		If @error Then ExitLoop
		If $tmp Then $sOut &= @CRLF & $tmp
	WEnd
	GUICtrlSetState($iBtnStart, $GUI_ENABLE)
	If StringInStr($sOut, 'successfully') Then GUICtrlSetData($iStatusBar, GUICtrlRead($iStatusBar) & '   ' & $Lng[15])
	; Return SetError($tmp, 0, $sOut)
	$sOut = $Lng[16] & @CRLF & _
			'Path: ' & @TAB & $sPathBootSect & @CRLF & _
			'ComString: ' & @TAB & $sComString & @CRLF & @CRLF & _
			$Lng[17] & @CRLF & _
			_Encoding_866To1251($sOut) & @CRLF & _
			$Lng[18]
	Return $sOut
EndFunc   ;==>_BootSect

Func _Help()
	Local $iPID, $sOut, $tmp
	$iPID = Run('"' & $sPathBootSect & '" /help', @ScriptDir, @SW_HIDE, $STDOUT_CHILD)
	While 1
		$tmp = StdoutRead($iPID)
		If @error Then ExitLoop
		If $tmp Then $sOut &= @CRLF & $tmp
	WEnd
	Return _Encoding_866To1251($sOut)
EndFunc   ;==>_Help

Func _Viewing($hGUI, $sLog)
	Local $hGuiLog, $aRect, $iEdit
	$aRect = _GetChildCoor($hGUI, 560, 450)
	GUISetState(@SW_DISABLE, $hGUI)

	$hGuiLog = GUICreate($Lng[19], $aRect[0], $aRect[1], $aRect[2], $aRect[3], BitOR($WS_OVERLAPPEDWINDOW, $WS_POPUP), -1, $hGUI)
	If Not @Compiled Then GUISetIcon(@ScriptDir & '\BootSectGui.ico')

	$iEdit = GUICtrlCreateEdit('', 0, 0, $aRect[0], $aRect[1])

	GUISetState(@SW_SHOW, $hGuiLog)

	GUICtrlSetData($iEdit, $sLog)

	Do
	Until GUIGetMsg() = $GUI_EVENT_CLOSE
	GUISetState(@SW_ENABLE, $hGUI)
	GUIDelete($hGuiLog)
EndFunc   ;==>_Viewing

Func _GetDrv()
	Local $sInfo = _ComboListDrive('Fixed')
	$sInfo &= _ComboListDrive('Removable')
	Return StringTrimLeft($sInfo, 1)
EndFunc   ;==>_GetDrv

Func _ComboListDrive($Type) ; coded by AZJIO (2013.01.26)
	Local $aDrive = DriveGetDrive($Type), $list = '', $sString, $sLabel, $aDisc_Partition
	If @error Then Return ''
	If $Type = 'Removable' Then $Type = 'Rem'
	For $i = 1 To $aDrive[0]
		If $aDrive[$i] = 'A:' Or $aDrive[$i] = 'B:' Then ContinueLoop
		$sLabel = DriveGetLabel($aDrive[$i])
		If StringLen($sLabel) > 15 Then $sLabel = StringLeft($sLabel, 12) & '...'
		$aDisc_Partition = _GetDiskNimberForDrive($aDrive[$i])
		; If @error Then Local $aDisc_Partition[2] = ['?', '?']
		$sString = StringFormat('%2s:%-2s %-2s %-5s %-15s %-5s ', $aDisc_Partition[0], $aDisc_Partition[1], StringUpper($aDrive[$i]), $Type, $sLabel, _
				DriveGetFileSystem($aDrive[$i])) & _GetSize(DriveSpaceTotal($aDrive[$i])) & ' ' & $Lng[20]
		$list &= $sp & $sString
	Next
	Return $list
EndFunc   ;==>_ComboListDrive

Func _GetSize($s) ; coded by AZJIO
	$s = StringFormat('%.03f', $s / 1024)
	If StringLen($s) > 7 Then $s = StringRegExpReplace(StringTrimRight($s, 4), '(\A\d{1,3}(?=(\d{3})+\z)|\d{3}(?=\d))', '\1 ') & StringRight($s, 4)
	Return StringFormat('%9s', $s) ; 9 
EndFunc   ;==>_GetSize

Func _AddDash($s, $i, ByRef $sWord)
	If Not StringIsDigit($i) Then Return
	Local $iLen = StringLen($sWord)
	If $iLen > $i - 2 Then Return
	$i = Int(($i - $iLen) / 2)
	Local $sDash = StringReplace(StringFormat('%0' & $i & 'd', '0'), '0', $s, 0, 2)
	$sWord = $sDash & ' ' & $sWord & ' ' & $sDash
EndFunc   ;==>_AddDash


; http://www.autoitscript.com/forum/topic/91598-get-disk-number-from-drive-letter/?p=659721
;  ........:         n:n (< >:< >)
; :
;		$sDriveLetter -    ,  C:
;					 ,  -1, @error:
;                  |1 -  CreateFile,    
;                  |2 -   
;                  |3 -   DeviceIoControl
;                  |4 -   
Func _GetDiskNimberForDrive($sDriveLetter) ;  

	Local $aDrive[2] = ['?', '?']

	Local $a_hCall = DllCall("kernel32.dll", "hwnd", "CreateFile", _
			"str", "\\.\" & $sDriveLetter, _;  
			"dword", 0, _
			"dword", 0, _
			"ptr", 0, _
			"dword", 3, _; OPEN_EXISTING
			"dword", 128, _; FILE_ATTRIBUTE_NORMAL
			"ptr", 0)

	If @error Then
		Return SetError(1, 0, $aDrive);    .  -.
	EndIf

	If $a_hCall[0] = -1 Then
		Return SetError(2, 0, $aDrive) ;   
	EndIf

	Local $hDevice = $a_hCall[0]

	Local $tIOCTL_STORAGE_GET_DEVICE_NUMBER = DllStructCreate("dword DeviceType;" & _
			"dword DeviceNumber;" & _
			"int PartitionNumber")

	Local $a_iCall = DllCall("kernel32.dll", "int", "DeviceIoControl", _
			"hwnd", $hDevice, _
			"dword", 0x2D1080, _; IOCTL_STORAGE_GET_DEVICE_NUMBER
			"ptr", 0, _
			"dword", 0, _
			"ptr", DllStructGetPtr($tIOCTL_STORAGE_GET_DEVICE_NUMBER), _
			"dword", DllStructGetSize($tIOCTL_STORAGE_GET_DEVICE_NUMBER), _
			"dword*", 0, _
			"ptr", 0)

	If @error Or Not $a_hCall[0] Then
		DllCall("kernel32.dll", "int", "CloseHandle", "hwnd", $hDevice)
		Return SetError(3, 0, $aDrive);   DeviceIoControl
	EndIf

	DllCall("kernel32.dll", "int", "CloseHandle", "hwnd", $hDevice)

	If DllStructGetData($tIOCTL_STORAGE_GET_DEVICE_NUMBER, "DeviceType") = 7 Then; FILE_DEVICE_DISK
		$aDrive[0] = DllStructGetData($tIOCTL_STORAGE_GET_DEVICE_NUMBER, "DeviceNumber")
		$aDrive[1] = DllStructGetData($tIOCTL_STORAGE_GET_DEVICE_NUMBER, "PartitionNumber")
		Return SetError(0, 0, $aDrive)
	EndIf

	Return SetError(4, 0, $aDrive);   

EndFunc   ;==>_GetDiskNimberForDrive

Func _GetPath($sFile)
	Local $tmp = _WinAPI_PathFindOnPath($sFile, @ScriptDir)
	If Not @error Then Return $tmp
	;       %PATH%,    
	If FileExists(@SystemDir & '\' & $sFile) Then
		Return @SystemDir & '\' & $sFile
	ElseIf FileExists(@WindowsDir & '\' & $sFile) Then
		Return @WindowsDir & '\' & $sFile
	EndIf
	Return SetError(1)
EndFunc   ;==>_GetPath